/**
 * Created with JetBrains PhpStorm.
 * User: Royee
 * Date: 13-8-20
 * Time: 下午1:53
 * 统计规则
 * _gm_srd 搜索引擎来源域名
 * _gm_srw 搜索引擎来源关键字
 * _gm_vr  访问来源轨迹，以$$$分割
 * _gm_av  广告来源记录
 * _gm_er  最后站外来路
 */


/*****host解析*****/
function getUrlHost(obj){
    var durl=/http[s]{0,1}:\/\/([^\/]+)\//i;
    return obj.match(durl)[1];
};


var msAnalytics = function () {

    var domain = 'gm99.com';
    var searchDomain = [ 'yahoo.com', 'google.com', 'bing.com'];
    var maxReferrerTrack = 2;

    /**
     * 解析url的search
     * @param url
     * @return {Object}
     */
    var urlParams = function (url) {
        var args = {};
        // 取查询字符串，以 & 符分开成数组
        var pairs = url.substring(url.indexOf("?") + 1, url.length).split("&");
        var pairsLen = pairs.length;
        for (var i = 0; i < pairsLen; i++) {
            // 查找 "name=value" 对，若不成对，则跳出循环继续下一对
            var pos = pairs[i].indexOf('=');
            if (pos == -1) continue;

            // 取参数名，參數值
            var argname = pairs[i].substring(0, pos);
            var value = pairs[i].substring(pos + 1);

            // 存成对象的一个属性
            args[argname] = decodeURIComponent(value);
        }

        return args;
    };

    /**
     * 設置Cookie
     * @param name
     * @param value
     * @param expires 有效时间秒s
     */
    var setCookie = function (name, value, expires) {
        var expiresStr = '';

        if (expires > 0) {
            var exp = new Date();
            exp.setTime(exp.getTime() + expires * 1000);
            expiresStr = ";expires=" + exp.toUTCString();
        } else {
            //此 cookie 将在视窗关闭后失效
            expires = 0;
            //if (navigator.appName){}
        }

        document.cookie = name + "=" + escape(value) + expiresStr + ";path=/;domain=" + domain + ";";
    };

    /**
     * 獲得Cookie
     * @param name
     * @returns {*}
     */
    var getCookie = function (name) {
        var arr = document.cookie.match(new RegExp("(^| )" + name + "=([^;]*)(;|$)"));
        if (arr != null) return unescape(arr[2]);
        return null;
    };

    /**
     * 刪除Cookie
     * @param name
     */
    var delCookie = function (name) {
        var exp = new Date();
        exp.setTime(exp.getTime() - 1);
        var cval = getCookie(name);
        if (cval != null) document.cookie = name + "=" + cval + ";expires=" + exp.toUTCString();
    };

    /**
     * 设置需要记录的搜索引擎域名
     * @param domain
     */
    this.setSearchDomain = function (domain) {
        searchDomain.push(domain);
    };

    /**
     * 记录访问来源cookie
     */
    this.registerReferrer = function () {
        //访问来源
        var referrer = document.referrer;

        if (referrer) {
            var word, params;
            var rDomain = searchDomain || [ 'google.com'];

            for (var i = 0; i < rDomain.length; i++) {
                if (referrer.indexOf(rDomain[i]) > 0) {
                    //設置緩存
                    setCookie('_gm_srd', rDomain[i], 86400);

                    //这里解析url参数
                    params = urlParams(referrer);

                    //這裡，很糾結，雅虎是p接關鍵字，而其他是q
                    if (referrer.indexOf('yahoo.com') > 0) {
                        word = params.p || '';
                    } else {
                        word = params.q || '';
                    }

                    setCookie('_gm_srw', encodeURIComponent(word), 86400);
                    break;
                }
            }
        }
    };

    /**
     * 记录进入游戏的轨迹cookie
     */
    this.enterGameReferrer = function () {
        var referrer = document.referrer;
        var fromAd = getCookie('_gm_av');

        if (referrer && (fromAd == null || fromAd == undefined)) {
            var vistorReferrers = getCookie('_gm_vr');
            var refs = vistorReferrers == null ? [] : vistorReferrers.split('$$$');
            var lastRef = refs.pop();

            //最后一次来源相同则忽略
            if (lastRef != encodeURIComponent(referrer)) {
                if (refs.length >= 0 && refs.length < (maxReferrerTrack - 1) && lastRef != undefined) {
                    refs.push(lastRef);
                }
                refs.push(encodeURIComponent(referrer));

                setCookie('_gm_vr', refs.join('$$$'), 0);
            } else {
                refs.push(lastRef);
            }
        }
    };
    /**
     * 注册来源渠道cookie
     */
    this.msckeckid = function (){
        var referrer = document.referrer;
        var host = window.location.host;
        var params = urlParams(location.href);
        var scid = params['scid'];
        var cid = parseInt(params['cid']);
        if(scid != '' &&  cid > 0){
            setCookie("scid", scid, 0);
            setCookie("cid", cid, 0);
            return false;
        } else if(referrer){
            var _coparison = getUrlHost(referrer);
            if(_coparison != host && referrer != getCookie('_gm_er')){
                //設置緩存
                setCookie('_gm_er', referrer, 0);
            }
        };
    };

};

var msGmA = new msAnalytics();
msGmA.registerReferrer();
msGmA.enterGameReferrer();
msGmA.msckeckid();